package com.gxzc.zen.api.sys.service

import com.gxzc.zen.api.sys.model.SysDictValue
import com.gxzc.zen.common.base.BaseService

/**
 * <p>
 * 字典值 服务类
 * </p>
 *
 * @author NorthLan
 * @since 2018-04-28
 */
interface ISysDictValueService : BaseService<SysDictValue> {
    /**
     * 初始化 dict value
     */
    fun init()

    /**
     * 获取缓存中所有的 字典值
     */
    fun getListCacheable(): MutableList<SysDictValue>

    /**
     * 删除所有 typeid 指定的字典值
     */
    fun deleteByTypeId(typeId: Long)

    /**
     * 获取所有typeid下的dict-value
     */
    fun getListByTypeId(typeId: Long?): MutableList<SysDictValue>

    /**
     * 插入一条dict-value
     */
    fun insertDictValue(entity: SysDictValue): SysDictValue

    /**
     * 更新一条数据,不包含移动位置
     */
    fun updateDictValue(entity: SysDictValue): SysDictValue

    /**
     * 删除一条记录
     */
    fun deleteDictValue(id: Long)

    /**
     * 根据type_code(code前缀)获取字典值列表
     */
    fun getDictValueListByTypeCode(typeCode: String): MutableList<SysDictValue>

    /**
     * 根据code值与value获取指定字典值
     */
    fun getDictValueByCodeAndValue(code: String, value: String): SysDictValue?

    /**
     * 根据code前缀与value获取指定字典值
     */
    fun getDictValueByPrefixAndValue(prefix: String, value: String): SysDictValue?
}
