package com.gxzc.zen

import com.gxzc.zen.api.sys.service.ISysDictValueService
import org.slf4j.LoggerFactory
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.boot.ApplicationArguments
import org.springframework.boot.ApplicationRunner
import org.springframework.stereotype.Component

/**
 * 启动加载
 * @author NorthLan
 * @date 2018/5/5
 * @url https://noahlan.com
 */
@Component
class ApplicationRunner : ApplicationRunner {
    companion object {
        private val logger = LoggerFactory.getLogger(ApplicationRunner::class.java)
    }

    @Autowired
    private lateinit var dictValueService: ISysDictValueService

    override fun run(args: ApplicationArguments?) {
        logger.info("Started successful. Initializing...")

        logger.info("Initializing DictValue...")
        dictValueService.init()
    }
}